'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: D2T to PNG converter
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Timer
Import BRL.Retro
Import MaxGUI.Win32MaxGUIEx

' modules which may be required:
 Import brl.PNGLoader
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader
Include "GBAGFX.bmx"
SetGraphicsDriver D3D7Max2DDriver() 
Print "Doom II GBA - Modding Tools - http://kippykip.com"
Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function

'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf
Global Palette:String = "decompile\PALETTE\PLAYPAL.1.D2P"
If(AppArgs.length > 1) 
	Palette:String = AppArgs[1] 
	Print "Loading Palette: " + Palette:String
	If (FileType(Palette:String) = 0) 
		Crash("Palette not found!: " + Palette:String) 
		'End
	EndIf
EndIf
GFX.KLoadPalette(Palette:String) 
Print "Converting with palette '" + Palette:String + "'."

Function ConvertFile(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("bin\" + TMP_FileName:String + ".txt") 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("COUNT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("COUNT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Count:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "IMAGE" Or TMP_Type:String = "TIMAGE") 
		TMP_SourceFile:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".D2I"
		TMP_DestFile:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".PNG"
		Print("Converting Image: " + TMP_SourceFile:String) 
		If(TMP_Type:String = "TIMAGE") 
			GFX.KConvertImage(TMP_SourceFile:String, TMP_Width:Int, TMP_Height:Int, False, True, TMP_DestFile:String) 
		Else
			GFX.KConvertImage(TMP_SourceFile:String, TMP_Width:Int, TMP_Height:Int, True, True, TMP_DestFile:String) 
		EndIf
		Print("Successfully converted to: " + TMP_DestFile:String) 
	EndIf
	If(TMP_Type:String = "SPRITE" Or TMP_Type:String = "TEXTURE" Or TMP_Type:String = "FLAT") 
		TMP_SourceFileH:TBank = LoadBank("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		TMP_SourceFileX1:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"
		TMP_SourceFileX2:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		TMP_SourceFileX3:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		TMP_SourceFileX4:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		TMP_SourceFileX5:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		TMP_SourceFileX6:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		TMP_SourceFileX7:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		TMP_SourceFileX8:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		TMP_DestFileX1:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.PNG"
		TMP_DestFileX2:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.PNG"
		TMP_DestFileX3:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.PNG"
		TMP_DestFileX4:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.PNG"
		TMP_DestFileX5:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.PNG"
		TMP_DestFileX6:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.PNG"
		TMP_DestFileX7:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.PNG"
		TMP_DestFileX8:String = "decompile\png\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.PNG"
		TMP_X1Width:Int = PeekInt(TMP_SourceFileH:TBank, 8) 
		TMP_X1Height:Int = PeekInt(TMP_SourceFileH:TBank, 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		'Print TMP_DestFileX1:String
		If(TMP_Type:String = "FLAT") 
			Print("Converting 7: " + TMP_Type:String) 
		Else
			Print("Converting 8: " + TMP_Type:String) 
			GFX.KConvertTexture(TMP_SourceFileX1:String, TMP_X1Width, TMP_X1Height, False, True, TMP_DestFileX1:String) 
			Print("Successfully converted to: " + TMP_DestFileX1:String) 
		endif
		GFX.KConvertTexture(TMP_SourceFileX2:String, TMP_X2Width, TMP_X2Height, False, True, TMP_DestFileX2:String) 
		Print("Successfully converted to: " + TMP_DestFileX2:String) 
		GFX.KConvertTexture(TMP_SourceFileX3:String, TMP_X3Width, TMP_X3Height, False, True, TMP_DestFileX3:String) 
		Print("Successfully converted to: " + TMP_DestFileX3:String) 
		GFX.KConvertTexture(TMP_SourceFileX4:String, TMP_X4Width, TMP_X4Height, False, True, TMP_DestFileX4:String) 
		Print("Successfully converted to: " + TMP_DestFileX4:String) 
		GFX.KConvertTexture(TMP_SourceFileX5:String, TMP_X5Width, TMP_X5Height, False, True, TMP_DestFileX5:String) 
		Print("Successfully converted to: " + TMP_DestFileX5:String) 
		GFX.KConvertTexture(TMP_SourceFileX6:String, TMP_X6Width, TMP_X6Height, False, True, TMP_DestFileX6:String) 
		Print("Successfully converted to: " + TMP_DestFileX6:String) 
		GFX.KConvertTexture(TMP_SourceFileX7:String, TMP_X7Width, TMP_X7Height, False, True, TMP_DestFileX7:String) 
		Print("Successfully converted to: " + TMP_DestFileX7:String) 
		GFX.KConvertTexture(TMP_SourceFileX8:String, TMP_X8Width, TMP_X8Height, False, True, TMP_DestFileX8:String) 
		Print("Successfully converted to: " + TMP_DestFileX8:String) 
	EndIf
	If(TMP_Type:String = "PALETTE" Or TMP_Type:String = "555PALETTE") 
		For TMP_CurrentByte = 1 To TMP_Count:Int
			TMP_SourceFile:String = "decompile\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentByte + ".D2P"
			TMP_DestFile:String = "decompile\png\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentByte + ".PNG"
			If(TMP_Count:Int = 1) 
				TMP_SourceFile:String = "decompile\PALETTE\" + TMP_FileName:String + ".D2P"
				TMP_DestFile:String = "decompile\png\PALETTE\" + TMP_FileName:String + ".PNG"
			EndIf
			Print("Converting Palette: " + TMP_SourceFile:String) 
			GFX.KConvertPalette(TMP_SourceFile:String, True, TMP_DestFile:String) 
			Print("Successfully converted to: " + TMP_DestFile:String) 
		Next
	EndIf
EndFunction

If(AppArgs.length > 2) 
	Local SplitFN:String[] = AppArgs[2].Split("\") 
	LoadedFN:String = Upper:String(SplitFN[SplitFN.Length - 1] ) 
	Local SplitFN2:String[] = LoadedFN:String.Split(".") 
	If (FileType("bin\" + SplitFN2[0] + ".txt") = 0) 
		Crash("Header not found!: " + "bin\" + SplitFN2[0] + ".txt") 
		End
	EndIf
	Print "Loading: " + "bin\" + SplitFN2[0] + ".txt"
	ConvertFile(SplitFN2[0] ) 
Else
	Repeat
		TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
		If(TMP_CurrentFile:String = "") 
			Exit
		ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
			If(TMP_CurrentFile:String.EndsWith(".TXT")) 
				Print "Loading: " + TMP_CurrentFile:String
				ConvertFile(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
			EndIf
		EndIf
	Forever
EndIf
Print "Successfully converted all files."