'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Graphic Viewer
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Timer
Import BRL.Retro
Import MaxGUI.Win32MaxGUIEx

' modules which may be required:
 Import brl.PNGLoader
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader


SetGraphicsDriver D3D7Max2DDriver()
Print "Doom II GBA - Modding Tools - http://kippykip.com"


Include "GBAGFX.bmx"
'Dummy function here so I can fucking compile from importing KGFX.
Global Timer = CreateTimer(30) 
Global TMP_BANK:TBank
Global TexHeader:TBank
Global LoadedGraphic:TImage
AppTitle:String = "GBA Doom II Graphic Viewer: ERROR"
Global Palette:String = "decompile\PALETTE\PLAYPAL.1.D2P"
If(AppArgs.length > 1) 
	TMP_BANK:TBank = LoadBank(AppArgs[1] ) 
	If(AppArgs.length > 2) 
		Palette:String = AppArgs[2] 
	EndIf
	If Not(TMP_BANK) 
		Notify("Graphic doesn't exist!", True) 
		End
	EndIf
Else
	Notify("Missing command line! Nothing to open!", True) 
	Notify("Arguments: GraphicReader.exe D2ObjectFileName D2Palette(optional)", True) 
	End
EndIf
If (FileType(Palette:String) = 0) 
	Notify("Palette not found!: " + Palette:String, True) 
	End
EndIf
Global SplitFN:String[] = AppArgs[1].Split("\") 
Global CurrentFolder:String
For x = 0 To SplitFN.Length - 2
	CurrentFolder:String = CurrentFolder:String + SplitFN[x] + "\"
Next
Global LoadedFN:String = Upper:String(SplitFN[SplitFN.Length - 1] ) 
Global SplitFN2:String[] = LoadedFN:String.Split(".") 
Global IgnoreTransparency = False
Global IsD2IMG = False
Global Width:Int = 0
Global Height:Int = 0
If(Right:String(LoadedFN:String, 4) = ".D2I") 
	IsD2IMG = True
	GetHeaderInfo() 
Else
	If(FileType(CurrentFolder:String + SplitFN2[0] + ".H") = 1) 
		TexHeader:TBank = LoadBank(CurrentFolder:String + SplitFN2[0] + ".H")        'Load the header
	ElseIf(FileType("DECOMPILE\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + ".H") = 1) 
		TexHeader:TBank = LoadBank("DECOMPILE\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + ".H")            'Load the header
	Else
		Notify("'" + "DECOMPILE\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + ".H' is missing!", True) 
		End
	EndIf
	Width:Int = PeekInt(TexHeader:TBank, 8) 
	Height:Int = PeekInt(TexHeader:TBank, 4) 
	If(SplitFN2[1] = "X2") 
		Width:Int = Width:Int / 2
		Height:Int = Height:Int / 2
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X3") 
		Width:Int = Width:Int / 4
		Height:Int = Height:Int / 4
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X4") 
		Width:Int = Width:Int / 8
		Height:Int = Height:Int / 8
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X5") 
		Width:Int = Width:Int / 16
		Height:Int = Height:Int / 16
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X6") 
		Width:Int = Width:Int / 32
		Height:Int = Height:Int / 32
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X7") 
		Width:Int = Width:Int / 64
		Height:Int = Height:Int / 64
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] = "X8") 
		Width:Int = Width:Int / 128
		Height:Int = Height:Int / 128
		If(Width:Int < 1) 
			Width:Int = 1
		EndIf
		If(Height:Int < 1) 
			Height:Int = 1
		EndIf
	ElseIf(SplitFN2[1] <> "X1") 
		Notify("Unknown texture/sprite size!", True) 
		End	
	EndIf
EndIf
Function GetHeaderInfo() 
	TMP_FileName:String = "bin\" + SplitFN2[0] + ".txt"
	If (FileType(TMP_FileName:String) = 0) 
		Notify("Header not found!: " + HeaderFN:String, True) 
		End
	EndIf
	TMP_CurrentTXT:TStream = ReadStream(TMP_FileName:String) 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "IMAGE") 
		Width = TMP_Width
		Height = TMP_Height
		IgnoreTransparency = True
	ElseIf(TMP_Type:String = "TIMAGE") 
		Width = TMP_Width
		Height = TMP_Height
	Else
		Notify("This is not an image according to the header!", True) 
		End
	EndIf
EndFunction
If(FileType("recompile\PALETTE\PLAYPAL.1.D2P") = 1 And Upper:String(AppArgs[1] ).Contains("RECOMPILE")) 
	Palette:String = "recompile\PALETTE\PLAYPAL.1.D2P"
EndIf
GFX.KLoadPalette(Palette:String) 

'Print SplitFN2[0] + ".H"
Global ResizeValue = 1
AppTitle:String = "GBA Doom II Graphic Viewer: " + Width + "x" + Height + ", " + AppArgs[1] + ", Palette: " + Palette:String
Graphics 800, 600, 0, 60
SetBlend(ALPHABLEND) 
Cls
If(IsD2IMG) 
	LoadedGraphic:TImage = GFX.KConvertImage(AppArgs[1] , Width, Height, IgnoreTransparency) 
Else
	LoadedGraphic:TImage = GFX.KConvertTexture(AppArgs[1] , Width, Height) 
EndIf
If(Width * 128 < GraphicsWidth() And Height * 128 < GraphicsHeight()) 
	ResizeValue = 128
ElseIf(Width * 64 < GraphicsWidth() And Height * 64 < GraphicsHeight()) 
	ResizeValue = 64
ElseIf(Width * 32 < GraphicsWidth() And Height * 32 < GraphicsHeight()) 
	ResizeValue = 32
ElseIf(Width * 16 < GraphicsWidth() And Height * 16 < GraphicsHeight()) 
	ResizeValue = 16
ElseIf(Width * 8 < GraphicsWidth() And Height * 8 < GraphicsHeight()) 
	ResizeValue = 8
ElseIf(Width * 4 < GraphicsWidth() And Height * 4 < GraphicsHeight()) 
	ResizeValue = 4
ElseIf(Width * 2 < GraphicsWidth() And Height * 2 < GraphicsHeight()) 
	ResizeValue = 2
Else
	ResizeValue = 1
EndIf

SetColor (238, 243, 250) 
DrawRect(0, 0, GraphicsWidth(), GraphicsHeight()) 
'SetColor (255, 255, 255) 
'Print AppArgs[1] 
'GFX.KConvertTexture(AppArgs[1] , Width, Height, True) 
Global exportedPNG = False
While Not(AppTerminate()) 
	WaitTimer(Timer) 
	Cls
	SetColor (238, 243, 250) 
	DrawRect(0, 0, GraphicsWidth(), GraphicsHeight()) 
	SetColor 0, 0, 0
	If(exportedPNG) 
		If(IsD2IMG) 
			DrawText("Exported to: " + "DECOMPILE\PNG\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + ".PNG", 2, GraphicsHeight() - 14) 
		Else
			DrawText("Exported to: " + "DECOMPILE\PNG\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + "." + SplitFN2[1] + ".PNG", 2, GraphicsHeight() - 14) 
		EndIf
	Else
		DrawText("Press Spacebar to export to PNG", 2, GraphicsHeight() - 14) 
	EndIf
	If(KeyDown(KEY_SPACE) And exportedPNG = False) 
		If(IsD2IMG) 
			GFX.KConvertImage(AppArgs[1] , Width, Height, IgnoreTransparency, True, "DECOMPILE\PNG\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + ".PNG") 
		Else
			GFX.KConvertTexture(AppArgs[1] , Width, Height, False, True, "DECOMPILE\PNG\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + "." + SplitFN2[1] + ".PNG") 
		EndIf
		exportedPNG = True
	EndIf
	SetColor 255, 255, 255
	DrawImageRect(LoadedGraphic, GraphicsWidth() / 2 - (Width * ResizeValue / 2), GraphicsHeight() / 2 - (Height * ResizeValue / 2), Width * ResizeValue, Height * ResizeValue) 
	If(ResizeValue > 1 And GraphicsWidth() / 2 - (Width * ResizeValue / 2) > Width Or ResizeValue > 1 And GraphicsHeight() / 2 - (Height * ResizeValue / 2) > Height) 
		DrawImage(LoadedGraphic, 0, 0) 
	EndIf
	Flip
WEnd