
'GFX.PNGResizeCanvas("APBXA0.png", "APBXA0-FIX.png", 64, 64, True) 
'GFX.PNGResizeCanvas("BBRNA0.png", "BBRNA0-FIX.png", 64, 128, False) 
'GFX.PNGResizeCanvas("MANFA1.png", "MANFA1-FIX.png", 64, 32, true) 
'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: PNG to D2T converter
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import brl.Timer
Import brl.Retro
Import maxgui.Win32MaxGUIEx
Import brl.StandardIO

' modules which may be required:
Import brl.PNGLoader
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader
Include "GBAGFX.bmx"
SetGraphicsDriver D3D7Max2DDriver() 
Print "Doom II GBA - Modding Tools - http://kippykip.com"
Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function

'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf

'Centered Images list
Global CenteredTXT:TStream
If(FileType("CenteredSprites.txt") = 1) 
	CenteredTXT:TStream = ReadStream("CenteredSprites.txt") 
	While Not Eof(CenteredTXT) 
		CenteredSprites.Add(ReadLine(CenteredTXT)) 
	Wend
Else
	Print "WARNING! 'CenteredSprites.txt' is missing! Sprite canvases will be defaulted to bottom-middle."
EndIf
Type CenteredSprites
	Global CenteredSprites_List:TList = New TList
	Field Name:String
	Function Add(TMP_Name:String) 
		Local CABNET:CenteredSprites = New CenteredSprites
		CABNET.Name:String = TMP_Name:String
		ListAddLast(CenteredSprites_List, CABNET) 
	EndFunction
	Function CheckCentered(TMP_Name:String) 
		For Local CABNET:CenteredSprites = EachIn CenteredSprites_List
			If(TMP_Name:String = CABNET.Name:String) 
				Return True
			EndIf
		Next
		Return False
	EndFunction
EndType

Function AdjustCanvas(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("bin\" + TMP_FileName:String + ".txt") 
	TMP_Type:String = ""
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "SPRITE") 
		TMP_HeaderFN:String = "decompile\SPRITE\" + TMP_FileName:String + ".H"
		TMP_PNGFN:String = "decompile\png\SPRITE\" + TMP_FileName:String + ".X1.PNG"
		If(FileType(TMP_PNGFN:String) = 1) 
			Print "PNG File: '" + TMP_PNGFN:String + "' exists! Resizing canvas..."
			If(FileType(TMP_HeaderFN:String) = 1) 
				Print "Loading header: '" + TMP_HeaderFN:String + "'."
				TMP_Header:TBank = LoadBank(TMP_HeaderFN:String) 
				TMP_Width:Int = PeekInt(TMP_Header:TBank, 8) 
				TMP_Height:Int = PeekInt(TMP_Header:TBank, 4) 
				TMP_ContainsM = False
				If(Right:String(TMP_FileName:String, 2) = "-M") 
					TMP_ContainsM = True
				EndIf
				Print "Modifiying PNG canvas size to: " + TMP_Width:Int + "x" + TMP_Height:Int
				GFX.PNGResizeCanvas(TMP_PNGFN:String, TMP_PNGFN:String, TMP_Width:Int, TMP_Height:Int, CenteredSprites.CheckCentered(TMP_FileName:String), TMP_ContainsM) 
				Print "Successfully resized PNG canvas."
			Else
				Print "WARNING! Missing Sprite Header '" + TMP_HeaderFN:String + "'. Have you decompiled?"
				Print "Ignoring canvas resize for: " + TMP_FileName:String
			EndIf
		Else
			Print "'" + TMP_PNGFN:String + "' is missing! Ignoring..."
		EndIf
	EndIf
EndFunction

If(AppArgs.length > 2) 
	Local SplitFN:String[] = AppArgs[2].Split("\") 
	LoadedFN:String = Upper:String(SplitFN[SplitFN.Length - 1] ) 
	Local SplitFN2:String[] = LoadedFN:String.Split(".") 
	If (FileType("bin\" + SplitFN2[0] + ".txt") = 0) 
		Crash("Header not found!: " + "bin\" + SplitFN2[0] + ".txt") 
		End
	EndIf
	'Print "Loading: " + "bin\" + SplitFN2[0] + ".txt"
	AdjustCanvas(SplitFN2[0] ) 
Else
	Repeat
		TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
		If(TMP_CurrentFile:String = "") 
			Exit
		ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
			If(TMP_CurrentFile:String.EndsWith(".TXT")) 
				'Print "Loading: " + TMP_CurrentFile:String
				AdjustCanvas(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
			EndIf
		EndIf
	Forever
EndIf
Print "Successfully converted all files."